#include "itbase.h"

using std::cout;
using std::endl;
using namespace itpp;

#ifdef NO_LAPACK
#define __THIS_PROGRAM_WILL_NOT_RUN__
#endif

#ifdef NO_CBLAS
#define __THIS_PROGRAM_WILL_NOT_RUN__
#endif

#ifdef __THIS_PROGRAM_WILL_NOT_RUN__
int main() { cout << "LAPACK and CBLAS is needed for this test program" << endl; }
#else

int main()
{

  cout << "================================" << endl;
  cout << "    Test of Cholesky routines" << endl;
  cout << "================================" << endl;

  {
    cout << "Real matrix" << endl;
    mat X = randn(5,5);
    X = transpose(X)*X; // create a positive def matrix
    mat F;
    chol(X, F);

    cout << "X = " << X << endl;
    cout << "F = " << F << endl;
    cout << "X = F^T * F = " << transpose(F) * F << endl;
    cout << "only F = " << chol(X) << endl;
  }

  {
    cout << endl << "Complex matrix" << endl;
    cmat X = randn_c(5,5);
    X = transpose(conj(X))*X; // create a positive def matrix
    cmat F;
    chol(X, F);

    cout << "X = " << X << endl;
    cout << "F = " << F << endl;
    cout << "X = F^H * F = " << transpose(conj(F)) * F << endl;
    cout << "only F = " << chol(X) << endl;
  }

  return 0;

}

#endif
